"{ Package: 'jv:calipel/s' }"

"{ NameSpace: Smalltalk }"

Object subclass:#Benchmark
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Core'
!

!Benchmark class methodsFor:'documentation'!

documentation
"
    Base abstract superclass for benchmarks.

    NOTE: There's no need to inherit from this class, everything
    is specified by annotations. However, this class provides some
    convenient class methods.

    [author:]
        Jan Vrany <jan.vrany@fit.cvut.cz>

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!Benchmark class methodsFor:'running'!

run
    "Run all benchmarks in this class. Returns benchmark results as instance of BenchmarkResultC"

    ^ (BenchmarkSuite class:self) run

    "Created: / 10-06-2013 / 21:53:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 30-10-2015 / 07:05:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

run: benchmark
    "Run benchmarks defined in method `benchmark` Returns benchmark result as instance of BenchmarkResultC"

    ^ (BenchmarkInstance class:self selector:benchmark) run

    "Created: / 31-05-2013 / 10:39:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-06-2013 / 21:53:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 30-10-2015 / 07:05:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

run: benchmark with: parameters
    "Run benchmark defined in method `benchmark` with given parameters.
     Returns benchmark results as instance of BenchmarkResultC.
     `parameters` id a Dictionary defining parameters and theit values
     (as strings).
     "          

    ^ (BenchmarkInstance class:self selector:benchmark) runWith: parameters

    "Created: / 10-03-2014 / 00:12:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 30-10-2015 / 07:07:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

spy: benchmark
    "Rum the benchmark under a Smalltalk profiler (MessageTally or whatever
     the platform provides)."

    ^ (BenchmarkInstance class:self selector:benchmark) spy

    "Created: / 30-10-2015 / 07:16:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!Benchmark class methodsFor:'testing'!

isAbstract
    ^ self == Benchmark

    "Created: / 11-03-2014 / 23:10:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

