"{ Package: 'jv:calipel/s/benchmarks/stx' }"

"{ NameSpace: Smalltalk }"

Object subclass:#BenchmarkFiles
	instanceVariableNames:'tmpdir1 filenames1'
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Benchmarks-St/X'
!


!BenchmarkFiles class methodsFor:'running'!

run
    "Run all benchmarks in this class. Returns benchmark results as instance of BenchmarkResultC"

    ^ (BenchmarkSuite class:self) run

    "Created: / 10-06-2013 / 21:53:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 30-10-2015 / 07:05:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

run: benchmark
    "Run benchmarks defined in method `benchmark` Returns benchmark result as instance of BenchmarkResultC"

    ^ (BenchmarkInstance class:self selector:benchmark) run

    "Created: / 31-05-2013 / 10:39:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-06-2013 / 21:53:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 30-10-2015 / 07:05:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

run: benchmark with: parameters
    "Run benchmark defined in method `benchmark` with given parameters.
     Returns benchmark results as instance of BenchmarkResultC.
     `parameters` id a Dictionary defining parameters and theit values
     (as strings).
     "          

    ^ (BenchmarkInstance class:self selector:benchmark) runWith: parameters

    "Created: / 10-03-2014 / 00:12:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 30-10-2015 / 07:07:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

spy: benchmark
    "Rum the benchmark under a Smalltalk profiler (MessageTally or whatever
     the platform provides)."

    ^ (BenchmarkInstance class:self selector:benchmark) spy

    "Created: / 30-10-2015 / 07:16:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkFiles methodsFor:'benchmarks'!

benchmarkExistsOpenReadClose
    <benchmark: 'File: exists, open, read, close'>
    <setup: #setupFilenames1>
    1000 timesRepeat:[
        filenames1 do:[:fn |
            | readstream |

            fn exists.
            readstream := fn readStream.
            readstream contents.
            readstream close.
        ].
    ].

    "
    BenchmarkFiles run: #benchmarkExistsOpenReadClose
    "

    "Created: / 30-10-2015 / 08:00:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkFiles methodsFor:'setup'!

setupFilenames1
    | pkgdef pkgdir |

    tmpdir1 := Filename newTemporaryDirectory.
    pkgdef := Smalltalk at: #'jv_calipel_s'.
    pkgdir := pkgdef packageDirectory.
    filenames1 := pkgdef classNames collect:[ :each | 
        | basename |

        basename := each , '.st'.
        (pkgdir / basename) copyTo: (tmpdir1 / basename).
        tmpdir1 / basename    
    ].

    "Created: / 30-10-2015 / 07:56:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 30-10-2015 / 11:48:46 / jv"
!

teardown
    <teardown>

    (tmpdir1 notNil and:[ tmpdir1 isDirectory ]) ifTrue:[ 
        tmpdir1 recursiveRemove.
    ].

    "Created: / 30-10-2015 / 11:49:43 / jv"
! !

!BenchmarkFiles class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

