"{ Package: 'jv:calipel/s/benchmarks/stx' }"

"{ NameSpace: Smalltalk }"

Benchmark subclass:#BenchmarkSimpleHanoi
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Benchmarks-St/X'
!

!BenchmarkSimpleHanoi class methodsFor:'documentation'!

results
"
    Transcript showCR:(self new hanoi)
    10 timesRepeat:[Transcript showCR:(self new hanoi);endEntry]

    ----------------- JIT ---------------

    Duo2.1Ghz winVista           0.062
    P6/700 linux-elf;egcs        0.23
    Celeron/500 linux-elf;egcs   0.325
    P6/400 linux-elf;egcs        0.4
    P6/266 winNT;bcc             0.60 (S)
    Ultra/250 sol2.6;egcs        0.61
    P6/266 linux-elf;gcc         0.61
    P6/266 win95;bcc             0.62 (S)
    alpha/433 osf1;cc            0.66
    hp b2000 cc                  0.74
    P5/200 win95;bcc             0.86 (N)(S)
    P5/200 linux-elf;gcc         1.13 (N)
    P5/150 linux-elf;gcc         1.24
    P5/133 linux-aout;gcc        1.40
    P5/120 linux-elf;gcc         1.74 (N2)
    r4000/150 irix5.3            1.92
    alpha/233 osf1;cc;taso       4.32 (1)
    ss10/40 solaris2.5;gcc       4.36
    alpha/233 osf1;cc            4.72 (1)
    486/50 linux-ELF             8.45
    68k/33Mhz next3.3           11.03
    320H aix3.2.5               12.39

    ----------------- NO JIT ---------------

    P6/400 linux-elf;egcs        7.6
    P6/266 win95;bcc            12.73 (S)
    P6/266 linux-elf;pgcc       13.19
    P5/200 win95;bcc            19.4  (N)
    P5/200 linux-elf;gcc        19.65 (N)
    r4000/150 irix5.3           27.0
    P5/133 linux-aout;gcc       33.16
    alpha/233 osf1;cc           68.26
    486/50 linux-ELF           132.46
    320H aix3.2.5              502.46

 Notice:
   (N) the was executed on a notebook with a poor memory interface and 256k
       cache. A regular P5/200 is somewhat faster.

   (N2)another notebook with a poor memory interface

   (1) the alpha is running 64 bit code (shuffling around twice as much data)
       the taso version is also 64bit, bit has its VM loaded into the lower 4Gig.

   (S) no stack overflow checks
"
! !

!BenchmarkSimpleHanoi methodsFor:'processing'!

hanoi
    <benchmark: 'Simple Hanoi'>

    100 timesRepeat:[  
        self move:22 from:1 to:3 temp:3.
    ]

    "
    (BenchmarkInstance class: BenchmarkSimpleHanoi selector: #hanoi) run
    "

    "Modified: / 12-11-1997 / 17:07:06 / cg"
    "Modified: / 24-09-2014 / 20:33:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

move:n from:src to:dst temp:tmp
    n == 1 ifTrue:[^ self].
    self move:n-1 from:src to:tmp temp:dst.
    self move:n-1 from:tmp to:dst temp:src

    "Created: / 12.11.1997 / 17:06:46 / cg"
! !

!BenchmarkSimpleHanoi class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

