"{ Package: 'jv:calipel/s/benchmarks/stx' }"

"{ NameSpace: Smalltalk }"

BenchmarkCollection subclass:#BenchmarkSortedCollectionLike
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Benchmarks-St/X'
!

!BenchmarkSortedCollectionLike class methodsFor:'sorted collections'!

test_Btree
    |coll sc randomNumbers|

    randomNumbers := (1 to:1000) collect:[:i |Random nextInteger].

    sc := SortedCollection new.
    sc addAll:randomNumbers.

    coll := BinaryTree new.
    coll addAll:randomNumbers.

    randomNumbers do:[:each |
"       
        Transcript showCR:'-----------'.
        Transcript showCR:(coll instVarNamed:'treeRoot').
        Transcript showCR:each.
"
        coll remove:each.
        sc remove:each.
        self assert:(sc asOrderedCollection = coll asOrderedCollection).
    ].

    "Modified (format): / 02-12-2014 / 23:58:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkSortedCollectionLike methodsFor:'benchmarks'!

benchmarkOrderedAscAddEnBloque  
    <benchmark: 'Insert ordered (asc) data individually'>

    collection := collectionClass new.
    collection addAll: (1 to: collectionDatasetSize)

    "Created: / 09-03-2014 / 10:23:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkOrderedAscAddIndividually
    <benchmark: 'Insert ordered (asc) data individually'>

    collection := collectionClass new.
    1 to: collectionDatasetSize do:[:each | collection add:each]

    "Created: / 09-03-2014 / 10:20:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkOrderedAscRemoveIndividually
    <benchmark: 'Remove ordered (asc) data individually'>
    <setup: #(#setUpCollectionDataset1 #setUpCollectionDataset1OrderedAsc)>

    collectionDataset1OrderedAsc do:[:each | collection remove:each]

    "Created: / 09-03-2014 / 10:32:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-03-2014 / 23:45:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkOrderedDescAddEnBloque  
    <benchmark: 'Insert ordered (desc) data en-bloque'>

    collection := collectionClass new.
    collection addAll: (collectionDatasetSize downTo: 1)

    "Created: / 09-03-2014 / 10:24:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkOrderedDescAddIndividually
    <benchmark: 'Insert ordered (desc) data individually'>

    collection := collectionClass new.
    collectionDatasetSize downTo: 1 do:[:each | collection add:each]

    "Created: / 09-03-2014 / 10:21:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkOrderedDescRemoveIndividually
    <benchmark: 'Remove ordered (desc) data individually'>
    <setup: #(#setUpCollectionDataset1 #setUpCollectionDataset1OrderedDesc)>

    collectionDataset1OrderedDesc do:[:each | collection remove:each]

    "Created: / 09-03-2014 / 10:32:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-03-2014 / 23:44:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkRandomAddEnBloque
    <benchmark: 'Insert random data en-bloque'>

    collection := collectionClass new.
    collection addAll:collectionDataset1

    "Created: / 09-03-2014 / 10:18:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2014 / 11:31:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkRandomAddIndividually
    <benchmark: 'Insert random data individually'>

    collection := collectionClass new.
    collectionDataset1 do:[:each | collection add:each]

    "Created: / 09-03-2014 / 10:17:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchmarkRandomRemoveIndividually
    <benchmark: 'Remove random data individually'>
    <setup: #setUpCollectionDataset1>

    collectionDataset1 do:[:each | collection remove:each]

    "Created: / 09-03-2014 / 10:30:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-03-2014 / 23:45:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkSortedCollectionLike methodsFor:'parameters'!

collectionClassName:aSymbol
    <parameter: 'Collection class name to benchmark' type: #Symbol values: #(SortedCollection AATree BinaryTree)>

    super collectionClassName:aSymbol

    "Modified (format): / 09-03-2014 / 11:07:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkSortedCollectionLike methodsFor:'setup'!

setUpCollectionDataset1
    collection := collectionClass new.
    collection addAll: collectionDataset1

    "Created: / 09-03-2014 / 10:26:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

