#!/bin/bash
# 
# a CI job to run PetitCompiler benchmarks on Pharo
#
set -e

if [ ! -f "ci-pharo-common.sh" ]; then
   wget -O "ci-pharo-common.sh" https://bitbucket.org/janvrany/jv-calipel/raw/tip/s/pharo/ci/ci-pharo-common.sh
fi
. ci-pharo-common.sh

BENCHMARK_REPORT=results.json

function ci_upload_benchmark_results {
        if [ -f "$BENCHMARK_REPORT" ]; then
                curl 'https://swing.fit.cvut.cz/calipel/imports/push-import'  \
                    --user "$CALIPEL_USER:$CALIPEL_PASSWORD" \
                    --compressed \
                    -H 'Content-Type: application/json' \
                    --data "@$BENCHMARK_REPORT"
        fi
}




ci_pharo_download_pharo
ci_pharo_download_calipel

set +e
./pharo $IMAGE benchmark --json -o results.json \
 BenchmarkMicro \
 BenchmarkGameSuite#benchThreadRing \
 BenchmarkGameSuite#benchPiDigits \
 BenchmarkGameSuite#benchNBody \
 BenchmarkGameSuite#benchFasta \
 BenchmarkGameSuite#benchFannkuchRedux \
 BenchmarkGameSuite#benchBinaryTrees
status=$?
set -e

ci_upload_benchmark_results

exit $status


