#
# A set of functions to be used in PetitParser's Pharo CI jobs
#

# Set up some environment variables (if not set by CI)
if [ -z "$BUILD_NUMBER" ]; then
   BUILD_NUMBER=0
fi

IMAGE_BASE=CalipeL-S-$BUILD_NUMBER
IMAGE=$IMAGE_BASE.image

# A function to download Pharo. The version of Pharo 
# is taken from environment variable PHARO. If it's not
# defined, defaults to  Pharo 5.0 
function ci_pharo_download_pharo {
    if [ -z "$PHARO" ]; then
        PHARO=5.0
    fi

    if [ ! -x pharo-ui ]; then
        rm -rf pharo pharo-ui pharo-vm Pharo.image Pharo.changes
	case "$PHARO" in 
            5.0)
                wget -O- get.pharo.org/50+vm | bash
                ;;	
            4.0)
                wget -O- get.pharo.org/40+vm | bash
                ;;	
            3.0)
                wget -O- get.pharo.org/30+vm | bash
                ;;	
            *)
                echo "Unknown PHARO version: $PHARO"
                exit 1
        esac
    fi
}

# A function to download Calipel and build an image

function ci_pharo_download_calipel {
    ./pharo Pharo.image save $IMAGE_BASE
    ./pharo $IMAGE config http://smalltalkhub.com/mc/JanVrany/CalipeL-S/main ConfigurationOfCalipeLS --install=0.1
}

