class Runtime < ActiveRecord::Base

  belongs_to :language, inverse_of: :runtimes
  has_many :benchmark_configurations, inverse_of: :runtime

  validates_presence_of :language_id, :name

  def all_dates_when_performed
    SortedSet.new(benchmark_batches.map(&:performed_at).flatten).to_a
  end

end

# == Schema Information
#
# Table name: runtimes
#
#  id          :integer          not null, primary key
#  name        :string(255)
#  language_id :integer
#  created_at  :datetime
#  updated_at  :datetime
#

