class Tag < ActiveRecord::Base

  has_and_belongs_to_many :benchmark_batches

  def all_configurations
    benchmark_batches.map(&:benchmark_configuration).uniq
  end

  def benchmark_batches_latest_for(benchmark_configuration)
    benchmark_batches.
      where(benchmark_configuration: benchmark_configuration)
  end


  def latest_results_for(benchmark_info, benchmark_configuration)
    benchmark_batches.
      joins(:benchmark_results).
      where(benchmark_configuration: benchmark_configuration,
            benchmark_results: { benchmark_info: benchmark_info }).
      max { |a, b| a.performed_at <=> b.performed_at }.
      result_for(benchmark_info)
  end

end
