desc "Fetches production database"
task :'db:seed:production' do
  `scp  "swing.fit.cvut.cz:/home/hlopkmar/calipel/current/db/production.sqlite3" "db/development.sqlite3"`
end

desc "Fetches production archive and seeds local database from it"
task :'db:seed:production-archive' => [ :'db:drop', :'db:create', :'db:migrate' ] do
  tmp_production_archive = File.expand_path("../tmp/production-archive", __FILE__)
  if not File.exist?(tmp_production_archive) then
    mkdir_p tmp_production_archive
  end
  if not system("rsync swing.fit.cvut.cz:/home/hlopkmar/calipel/current/public/uploads/archive/*.json #{tmp_production_archive}" ) then
    raise Exception.new("Cannot rsync archive")
  end
  if not system("rails r \"require File.join(Rails.root, 'db' , 'seeds-common'); db_seed(File.join(Rails.root, 'tmp', 'production-archive'))\"" ) then
    raise Exception.new("Canno seed database")
  end
end